/* Copyright (C) 2000-2013 Lavtech.com corp. All rights reserved.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
*/

#ifndef _UDM_CONTENTENCODING_H
#define _UDM_CONTENTENCODING_H

extern udm_content_encoding_t UdmContentEncodingID(const char *ce);
extern int UdmHTTPBufContentEncodingDecode(UDM_HTTPBUF *Buf, udm_content_encoding_t ce);

extern __C_LINK int __UDMCALL UdmDocUnGzip(UDM_DOCUMENT *Doc);
extern __C_LINK int __UDMCALL UdmDocInflate(UDM_DOCUMENT *Doc);
extern __C_LINK int __UDMCALL UdmDocUncompress(UDM_DOCUMENT *Doc);

#ifdef HAVE_ZLIB
size_t UdmInflate(char *dst, size_t dstlen, const char *src, size_t srclen, int *rc);
size_t UdmDeflate(char *dst, size_t dstlen, const char *src, size_t srclen, int *rc);
size_t UdmUnGzip(char *dst, size_t dstlen, const char *src, size_t srclen, int *rc);
size_t UdmUncompress(char *dst, size_t dstlen, const char *src, size_t srclen, int *rc);
#endif

/*****************************************************************************/

#endif
