/* Copyright (C) 2000-2013 Lavtech.com corp. All rights reserved.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
*/

#ifndef _UDM_HTTP_H
#define _UDM_HTTP_H

extern udm_content_type_t UdmContentTypeByName(const char *str);


extern size_t UdmHTTPFindContent(const char *src, size_t srclen);
extern void UdmParseHTTPResponse(UDM_AGENT * Indexer,UDM_DOCUMENT * Doc);
extern void UdmHTTPBufParseHeadersForCachedCopy(UDM_VARLIST *Vars, const char *src, size_t len);
extern int UdmStartHTTPD(UDM_AGENT *A, int (*routine)(int sock, UDM_AGENT *A));

extern const char *UdmHTTPBufPtr(const UDM_HTTPBUF *Buf);
extern const char *UdmHTTPBufContent(const UDM_HTTPBUF *Buf);
extern udm_bool_t UdmHTTPBufContentToConstStr(const UDM_HTTPBUF *Buf, UDM_CONST_STR *str);
extern size_t UdmHTTPBufContentSize(const UDM_HTTPBUF *Buf);
extern size_t UdmHTTPBufHeaderSize(const UDM_HTTPBUF *Buf);
extern size_t UdmHTTPBufSize(const UDM_HTTPBUF *Buf);
extern size_t UdmHTTPBufAllocedSize(const UDM_HTTPBUF *Buf);
extern size_t UdmHTTPBufAvailableSize(const UDM_HTTPBUF *Buf);
extern udmcrc32_t UdmHTTPBufCRC32(const UDM_HTTPBUF *Buf);
extern void UdmHTTPBufContentExport(const UDM_HTTPBUF *Buf, char *str);

extern void UdmHTTPBufInit(UDM_HTTPBUF *Buf);
extern void UdmHTTPBufReset(UDM_HTTPBUF *Buf);
extern void UdmHTTPBufPutContent(UDM_HTTPBUF *Buf, const char *src, size_t len);
extern void UdmHTTPBufResetContent(UDM_HTTPBUF *Buf);
extern int UdmHTTPBufAlloc(UDM_HTTPBUF *Buf, size_t size);
extern int UdmHTTPBufRealloc(UDM_HTTPBUF *Buf, size_t size);
extern void UdmHTTPBufFree(UDM_HTTPBUF *Buf);
extern void UdmHTTPBufTruncateContent(UDM_HTTPBUF *Buf);
/* TODO34: change notation of all functions below to return UDM_OK/UDM_ERROR*/
extern int UdmHTTPBufAppend(UDM_HTTPBUF *Buf, const char *src, size_t len);
extern int UdmHTTPBufAppendHTTPTime(UDM_HTTPBUF *Buf, time_t tm);
extern int UdmHTTPBufAppendf(UDM_HTTPBUF *Buf, const char *fmt, ...);
extern int UdmHTTPBufAppendFromFile(UDM_HTTPBUF *Buf, int fd);
extern int UdmHTTPBufAppendRecv(UDM_HTTPBUF *Buf, int fd, size_t len, int flags);
extern int UdmHTTPBufPrintf(UDM_HTTPBUF *Buf, const char *fmt, ...);
extern void UdmHTTPBufShiftLeft(UDM_HTTPBUF *Buf, size_t offs);
extern size_t UdmHTTPBufFindContent(UDM_HTTPBUF *Buf);
extern int UdmHTTPBufInflate(UDM_HTTPBUF *Buf, const char *src, size_t srclen);
extern int UdmHTTPBufInflateAppend(UDM_HTTPBUF *Buf, const char *src, size_t srclen);
extern int UdmHTTPBufDeflateAppend(UDM_HTTPBUF *Buf, const char *src, size_t srclen);
extern int UdmHTTPBufUnGzipAppend(UDM_HTTPBUF *Buf, const char *src, size_t srclen);
extern int UdmHTTPBufUncompressAppend(UDM_HTTPBUF *Buf, const char *src, size_t srclen);
extern int UdmHTTPBufAppendBase64Decode(UDM_HTTPBUF *Buf, const char *src, size_t srclen);
extern int UdmHTTPBufQuotedPrintableDecode(UDM_HTTPBUF *Buf, const char *src, size_t srclen);
extern int UdmHTTPBufAppendQuotedPrintableDecode(UDM_HTTPBUF *Buf, const char *src, size_t srclen);
extern int UdmHTTPBufBase64Decode(UDM_HTTPBUF *Buf, const char *src, size_t srclen);
extern int UdmHTTPBufAppendEncodingDecode(UDM_HTTPBUF *Buf, const char *src, size_t len, udm_content_encoding_t encoding);
#endif
