/* Copyright (C) 2000-2013 Lavtech.com corp. All rights reserved.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
*/

#ifndef __INDEXCACHE_H__
#define __INDEXCACHE_H__

#define INVERTED_INDEX_CACHE_PARTS     32
#define INVERTED_INDEX_CACHE_PART_SIZE ((4 * 1024 * 1024) / (INVERTED_INDEX_CACHE_PARTS))


void UdmInvertedIndexCachePartSort(UDM_INVERTED_INDEX_CACHE_PART *part);
void UdmInvertedIndexCachePartInit(UDM_INVERTED_INDEX_CACHE_PART *part);
void UdmInvertedIndexCachePartFree(UDM_INVERTED_INDEX_CACHE_PART *part);
int UdmInvertedIndexCacheAdd(UDM_AGENT *A,
                             UDM_CONSTWORD_HASH_DATA *data,
                             UDM_INVERTED_INDEX_CACHE *cache,
                             const UDM_WORD *W, size_t ncoords);
int UdmInvertedIndexCacheAllocParts(UDM_AGENT *A,
                                    UDM_INVERTED_INDEX_CACHE *cache,
                                    size_t n);

void UdmInvertedIndexCacheInit(UDM_INVERTED_INDEX_CACHE *L, UDM_ENV *Env);
void UdmInvertedIndexCacheReset(UDM_INVERTED_INDEX_CACHE *L);
void UdmInvertedIndexCacheFree(UDM_INVERTED_INDEX_CACHE *L);
int UdmInvertedIndexCacheAddPart(UDM_AGENT *A, UDM_INVERTED_INDEX_CACHE *cache);

int UdmConstWordListToInvertedIndexCoordList(UDM_INVERTED_INDEX_CACHE *cache,
                                             UDM_INVERTED_INDEX_COORD_LIST *CL,
                                             UDM_CONSTWORDLIST *CWL);

int UdmInvertedIndexCoordListInit(UDM_INVERTED_INDEX_COORD_LIST *L, size_t mitems);
void UdmInvertedIndexCoordListFree(UDM_INVERTED_INDEX_COORD_LIST *L);
void UdmInvertedIndexCoordListSort(UDM_INVERTED_INDEX_COORD_LIST *L);

int UdmInvertedIndexCoordList2InvertedIndexCache(UDM_AGENT *A,
                                                 UDM_INVERTED_INDEX_COORD_LIST *CL,
                                                 UDM_CONSTWORDLIST *CWLWithPos,
                                                 UDM_CONSTWORD_HASH_DATA *data,
                                                 UDM_INVERTED_INDEX_CACHE *L);

size_t udm_coord_put(size_t wc, unsigned char *r, unsigned char *e);
size_t udm_coord_get(size_t *wc, const unsigned char *s, const unsigned char *e);

#endif
